//Non funziona

package jsetl.test.CP;

import jsetl.*;

/*
 *      Prova constraint less su CP
 */

class Constraint_eq_CP {
    private static Solver solver = new Solver();
    public static void main (String[] args) {    
        LSet a = LSet.empty().ins(3).ins(1);       
        LSet b = LSet.empty().ins(2).ins(4);       
        CP cp = new CP("cp",a,b);   
        cp.output();				// {1,3} x {4,2}
        cp.expand().output();       // {[1,4],[1,2],[3,4],[3,2]}

        LSet R = new LSet("R");
        LVar X = new LVar("X");
        LSet S = R.ins(X).setName("S");   
        S.output();					// S = {_X|_R}
        
        solver.add(S.eq(cp));       // {_X|_R} = {1,3} x {4,2}
        solver.add(X.nin(R));       // X nin R
        
        if (solver.check())
        	System.out.println("true"); 
        else
        	System.out.println("false"); 
        X.output();
        R.output();
        
        solver.nextSolution();
        X.output();
        R.output();      

        solver.nextSolution();
        X.output();
        R.output();      

    }
}

/* Prova esecuzione:
cp = {1,3} x {4,2}
cp = {[1,4],[1,2],[3,4],[3,2]}
S = {_X|_R}
true
X = [1,4]
R = {[1,2],[3,4],[3,2]}
X = [_?,_?]
R = unknown
X = [_?,_?]
R = unknown


Risultati attesi:

X = [1,4],  
R = {[3,4],[3,2],[1,2]}

X = [1,2],  
R = {[3,2],[3,4],[1,4]}

X = [3,4],  
R = {[1,4],[1,2],[3,2]}

X = [3,2],  
R = {[1,2],[1,4],[3,4]}

*/