package jsetl.test.CP;

import org.junit.*;
import jsetl.*;

public class ProvaOutput {

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void outputInizializzato() {
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(5).ins(7);
		CP c = new CP("prodotto",A,B);
		System.out.print("output inizializzato: ");
		c.output(); 
	}
	
	@Test
	public void outputParzialmenteInizializzato() {
		LSet A = new LSet();
		LSet B = LSet.empty().ins(5).ins(7);
		CP c = new CP(A,B);
		System.out.print("output parzialmente inizializzato: ");
		c.output();
	}
	
	@Test
	public void outputNonInizializzato() {
		LSet A = new LSet();
		LSet B = new LSet();
		CP c = new CP(A,B);
		System.out.print("output non inizializzato: ");
		c.output();
	}
	
	@Test
	public void outputVuoto() {
		LSet A = LSet.empty();
		LSet B = LSet.empty();
		CP c = new CP(A,B);
		System.out.print("output vuoto: ");
		c.output();
	}
}
