package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

//import static org.junit.Assert.assertTrue;

import jsetl.exception.Failure;
import org.junit.*;
import jsetl.*;

public class ProvaUnion {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//TEST FALLIMENTARE
	@Test(expected = Failure.class)
	public void union1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(new LPair(1,2));
		LSet B = LSet.empty().ins(new LPair(3,4));
		LSet C = LSet.empty().ins(1).ins(3);
		LSet D = LSet.empty().ins(2).ins(4);
		CP cp = new CP(C,D);
		solver.solve(cp.union(A, B));
	}
	
	//UNIONE CON INSIEME VUOTO
	@Test
	public void union2() throws Throwable {
		Solver solver = new Solver();
		LSet A = new LSet();
		LSet B = LSet.empty();
		LSet C = LSet.empty().ins(1);
		LSet D = LSet.empty().ins(2);
		CP cp = new CP(C,D);
		solver.solve(cp.union(B,A));
		assertTrue(A.equals(cp.expand()));
	}
	
	//UNION CON TUTTO VARIABILE
	@Test
	public void union3() throws Throwable {
		Solver solver = new Solver();
		LSet A = new LSet();
		LSet B = new LSet();
		LSet C = new LSet();
		LSet D = LSet.empty().ins(2).ins(4);
		CP cp = new CP(C,D);
		solver.solve(cp.union(B,A));
	}
	
	@Test
	public void union5() throws Throwable {
		Solver solver = new Solver();
		LSet A = new LSet();
		LSet B = new LSet();
		LSet C = LSet.empty().ins(2);
		LSet D = LSet.empty().ins(1);
		CP cp = new CP(C,D);
		solver.solve(cp.union(A, B));
	}
}