
package jsetl.test.CP;

import jsetl.*;

/*
 *             Prova costruttori CP e expand
 */

class ProvaCostruttori_CP {
    public static void main (String[] args) {
        LSet A = LSet.empty().ins(1).ins(2);       // {1,2}
        A.output();
        LSet B = LSet.empty().ins('a').ins('b');   // {a,b}
        CP cp1 = new CP("cp1",A,B);                // {2,1} x {b,a}
        cp1.output();
        LSet C = cp1.expand();
        C.output();   
        
        LSet D = new LSet("D");
        CP cp2 = new CP("cp2",A,D);                // {2,1} x _D
        cp2.output();
        
 //      LSet E = cp2.expand();  // Exception: jsetl.exception.NotInitLObjectException   OK
 //      E.output();   
        
        LSet E = cp2.ins(new LPair(5,6)).setName("E");   // {[5,6]|{2,1} x _D}
        E.output();
       
    }
}

/* Prova esecuzione:

cp1 = {2,1} x {b,a}
cp1 = {[2,b],[2,a],[1,b],[1,a]}
cp2 = {2,1} x _D
E = {[5,6]|{2,1} x _D}

*/
