package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

import org.junit.*;
import jsetl.*;

public class ProvaDisj {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//PRIMA REGOLA DI RISCRITTURA
	@Test
	public void disj1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = LSet.empty();
		CP cp = new CP(A,B);
		solver.solve(cp.disj(C));
	}
	
	//SECONDA REGOLA DI RISCRITTURA
	@Test
	public void disj2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty();
		LSet C = LSet.empty().ins(2);
		CP cp = new CP(A,B);
		solver.solve(cp.disj(C));
	}
	
	//TERZA REGOLA DI RISCRITTURA
	@Test
	public void disj3() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty();
		LSet B = LSet.empty().ins(1);
		LSet C = LSet.empty().ins(2);
		CP cp = new CP(A,B);
		solver.solve(cp.disj(C));
	}
	
	//QUARTA REGOLA DI RISCRITTURA
	@Test
	public void disj4() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = new LSet();
		CP cp = new CP(A,B);
		solver.solve(cp.disj(C));
	}
	
	//QUINTA REGOLA DI RISCRITTURA
	@Test
	public void disj5() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = LSet.empty().ins(new LPair(4,3));
		CP cp = new CP(A,B);
		solver.solve(cp.disj(C));
	}
}
















