package jsetl.test.CP;

import jsetl.exception.NotInitLObjectException;
import org.junit.*;
import jsetl.*;

public class ProvaExpand {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//EXPAND SU UN CP INIZIALIZZATO
	@Test
	public void expandInizializzata() {
		LSet D = LSet.empty().ins(1).ins(2);
		LSet E = LSet.empty().ins(5).ins(7);
		CP f = new CP(D,E);
		@SuppressWarnings("unused")
		LSet R = f.expand();
	}
	
	//EXPAND SU UN CP NON INIZIALIZZATO
	@Test(expected = NotInitLObjectException.class)
	public void expandNonInizializzata() {
		LSet D = new LSet();
		LSet E = new LSet();
		CP f = new CP(D,E);
		@SuppressWarnings("unused")
		LSet R = f.expand();
	}
	
	//EXPAND SU UN CP PARZIALMENTE INIZIALIZZATO
	@Test(expected = NotInitLObjectException.class)
	public void expandParzialmenteInizializzata() {
		LSet D = new LSet();
		LSet E = LSet.empty().ins(5).ins(7);
		CP f = new CP(D,E);
		@SuppressWarnings("unused")
		LSet R = f.expand();
	}
	
	//EXPAND SU UN CP VUOTO
	@Test
	public void expandVuota() {
		LSet D = LSet.empty();
		LSet E = LSet.empty();
		CP f = new CP(D,E);
		@SuppressWarnings("unused")
		LSet R = f.expand();
	}
	
}
